import numpy as np

A = np.array([[1,2,3],[4,5,6]])
B = A.T @ A                      #   実対称行列
print('B =\n', B)

lmbd, u = np.linalg.eigh(B)      #   固有分解
print('lmbd =\n', lmbd)
print('u =\n', u)

ck_idx = np.abs(lmbd) > 1.0e-7   #   実質的に０でないと見做される値
print('ck_idx =\n', ck_idx)
lmbd = lmbd[ck_idx]              #   ０でない固有値の選択
print('lmbd =\n', lmbd)
u = u[:,ck_idx]                  #   ０でない固有値に対応する固有ベクトル
print('u =\n', u)

ck_ord = np.argsort(-lmbd)       #   大きい値から小さい値に対応する添え字
print('ck_ord =\n', ck_ord)

lmbd = lmbd[ck_ord]              #   固有値の並べ替え
print('lmbd =\n', lmbd)
u = u[:,ck_ord]                  #   固有ベクトルの並べ替え
print('u =\n', u)

ck_B = u @ np.diag(lmbd) @ u.T   #   固有分解の確認
print('ck_B =\n', ck_B)
